/*
  Copyright (C) 2005-2006 Dave Fischetti (dave@themediacouncil.com)
*/

var thisVersion = '2.0';

var _inDashboard = false;
var _inMozilla = false;
var req = new XMLHttpRequest(); 

function initWidget()
{
	createGenericButton(document.getElementById("postButton"), "Send Feedback", postFeedback);
	createGenericButton(document.getElementById("cancelButton"), "Cancel", cancelFeedback);
	createGenericButton(document.getElementById("doneButton"), "Done", saveConfig);
							
	if (window.widget) {
 		_inDashboard = true;
		
		widget.onhide = onHide;
		widget.onshow = onShow;

		document.getElementById("feed_first_name").value = (widget.preferenceForKey("feed_first_name") ? widget.preferenceForKey("feed_first_name") : "");
		document.getElementById("feed_last_name").value = (widget.preferenceForKey("feed_last_name") ? widget.preferenceForKey("feed_last_name") : "");
		document.getElementById("feed_email_address").value = (widget.preferenceForKey("feed_email_address") ? widget.preferenceForKey("feed_email_address") : "");
		document.getElementById("feed_extra_text").value = (widget.preferenceForKey("feed_extra_text") ? widget.preferenceForKey("feed_extra_text") : "");
		//document.getElementById("feed_sid").value = document.getElementById("feed_sid").value);
		//document.getElementById("feed_return_url").value = document.getElementById("feed_return_url").value);
		
	} else {
		_inDashboard = false;
	}

	if (netscape.security.PrivilegeManager) {
		_inMozilla = true;
	}
}

function onShow()
{
}

function onHide()
{
}

function flipRollie(mode)
{
	if (mode == "show") {
		document.getElementById("flipRollie").style.display = "block";
	} else {
		document.getElementById("flipRollie").style.display = "none";
	}
}

// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flipIcon');			// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flipIcon');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}



// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// **********************************************************************
// **********************************************************************
// SEPERATE FUNCTION TO FADE "FEEDBACK SENT" MESSAGE

var fadeMessage = {duration:0, starttime:0, to:0.0, now:1.0, from:1.0, firstElement:null, timer:null};

function fadeMessageGo()
{

		if (fadeMessage.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (fadeMessage.timer);
			fadeMessage.timer  = null;
		}
		
		var starttime = (new Date).getTime() + 1000;							// set it back one frame
		
		fadeMessage.duration = 500;												// animation time, in ms
		fadeMessage.starttime = starttime;										// specify the start time
		fadeMessage.firstElement = document.getElementById("blogStatus");		// specify the element to fade
		fadeMessage.timer = setInterval ("fadeMessageNow();", 13);				// set the animation function
		fadeMessage.from = fadeMessage.now;										// beginning opacity (not ness. 0)
		fadeMessage.to = 0.0;													// final opacity
		fadeMessageNow();
}

function fadeMessageNow()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-fadeMessage.starttime, 0, fadeMessage.duration);
	
	if (T >= fadeMessage.duration)
	{
		clearInterval (fadeMessage.timer);
		fadeMessage.timer = null;
		fadeMessage.now = fadeMessage.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / fadeMessage.duration));
		fadeMessage.now = computeNextFloat (fadeMessage.from, fadeMessage.to, ease);
	}
	
	fadeMessage.firstElement.style.opacity = fadeMessage.now;
}
// **********************************************************************
// **********************************************************************

function showConfig(event)
{
	if (_inDashboard) widget.prepareForTransition("ToBack");
	
	document.getElementById("mainPane").style.display = "none";
	document.getElementById("configPane").style.display = "block";
	document.getElementById("flipRollie").style.display = "none";

	if (_inDashboard) setTimeout('widget.performTransition();', 0);	
	return false;
}

function saveConfig(event)
{
	if (_inDashboard) widget.prepareForTransition("ToFront");
	 
	
	document.getElementById("configPane").style.display = "none";
	document.getElementById("mainPane").style.display = "block";
	setStatus("blogStatus","","#00FF00");

	if (_inDashboard) {
		widget.setPreferenceForKey(document.getElementById("feed_first_name").value, "feed_first_name");
		widget.setPreferenceForKey(document.getElementById("feed_last_name").value, "feed_last_name");
		widget.setPreferenceForKey(document.getElementById("feed_email_address").value, "feed_email_address");
		widget.setPreferenceForKey(document.getElementById("feed_extra_text").value, "feed_extra_text");
		widget.setPreferenceForKey(document.getElementById("feed_sid").value, "feed_sid");
		widget.setPreferenceForKey(document.getElementById("feed_return_url").value, "feed_return_url");
	}
	
	if (_inDashboard) setTimeout('widget.performTransition();', 0);
	versionCheck();
	return false;
}

function getPref(key)
{
	if (_inDashboard) {
		if (widget.preferenceForKey(key) != document.getElementById(key).value) {
			return document.getElementById(key).value;
		} else {
			return widget.preferenceForKey(key);
		}
	} else {
		return document.getElementById(key).value;
	}
}

function setStatus(id, text, color)
{
	var status = document.getElementById(id);
	var node   = document.createTextNode(text);
	status.style.opacity = 1.0;
	status.style.display = "inline";
	status.style.color   = color;
	
	if (status.firstChild) {
		status.replaceChild(node, status.firstChild);
	} else {
		status.appendChild(node);
	}
	
	if (color == "#00FF00" || color == "#FFFF00") {
		fadeMessage.now = 1.0;
		fadeMessage.from = 1.0;
		fadeMessageGo();
	}
	
}



function postFeedback(event)
{
	
   if (getPref("feed_first_name") == "") {
		setStatus("blogStatus", "Please enter your first name", "#FF0000");
		return;
   }
		
   if (getPref("feed_last_name") == "") {
		setStatus("blogStatus", "Please enter your last name", "#FF0000");
		return;
   }

   if (getPref("feed_email_address") == "") {
		setStatus("blogStatus", "Please enter your email address", "#FF0000");
		return;
   }
   
	if (document.getElementById("message").value == "") {
		setStatus("blogStatus", "Please enter a message.", "#FF0000");
		return;
   }
   
   if (document.getElementById("message").value.length < 10) {
		setStatus("blogStatus", "Message is too short.", "#FF0000");
		return;
   }
	
	document.frm.first_name.value = getPref("feed_first_name");
	document.frm.last_name.value = getPref("feed_last_name");
	document.frm.email_address.value = getPref("feed_email_address");
	document.frm.extra_text.value = getPref("feed_extra_text");
	document.frm.sid.value = getPref("feed_sid");
	document.frm.return_url.value = getPref("feed_return_url");
	
	document.getElementById("cancelButton").style.display = "inline";
	document.getElementById("postButton").style.display = "none";
	
	sendString = "first_name=" + document.frm.first_name.value + "&last_name=" + document.frm.last_name.value + "&email_address=" + document.frm.email_address.value + "&extra_text=" + document.frm.extra_text.value + "&sid=" + document.frm.sid.value + "&return_url=" + document.frm.return_url.value + "&message=" + document.frm.message.value + "&authorized=macwidget";

	if (_inMozilla) netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	
	try {
		
		url = "http://oa.instantfeedback.net/submit.php"; 
		req.open("POST", url ,false);
		req.onreadystatechange = finishPost;
		req.send(sendString);
		
	} catch (e) {
		setStatus("blogStatus", "Error", "#FF0000");
    }
	versionCheck();
}

function finishPost()
{
	
    if (_inMozilla) netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	
    if (req.readyState == 4) {
        if (req.status == 404) {
        	setStatus("Error finding page: Error 404", "#FF0000");
        } else if (req.status == 200) {
            
            setStatus("blogStatus", "Feedback sent!", "#00FF00");
			document.getElementById("message").value = "";
            
        }
    }

    document.getElementById("postButton").style.display = "inline";
    document.getElementById("cancelButton").style.display = "none";
    
}

function cancelFeedback()
{

	if (_inMozilla) netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");

	document.getElementById("postButton").style.display = "inline";
	document.getElementById("cancelButton").style.display = "none";
							
	setStatus("blogStatus", "Post cancelled", "#FFFF00");
	req.abort();
}


function openSite (theUrl) {

	theResult = true;
	if (window.widget) {
		widget.openURL(theUrl);
		theResult = false;
	}
	return theResult;

}

function versionCheck () {
	loadPage('http://www.themediacouncil.com/widgets/liveFeedback/version.xml', versionCompare,
		'id=com.themediacouncil.widgets.livefeedback');
}

function loadPage (theUrl,theFunction,theData) {

	xmlRequest = new XMLHttpRequest();
	xmlRequest.onload = theFunction;
	if (theData) {
		xmlRequest.open('GET',theUrl);
		xmlRequest.send(theData);
	}
}

function versionCompare () {
	
	if (xmlRequest.status == 200) {
	
		if (xmlRequest.responseXML) {
			
			var newestVersion = 0;
			var downloadUrl = '';

			for (child = xmlRequest.responseXML.firstChild; child != null; child = child.nextSibling) {
			
				if (child.nodeName == "versionstatus") {
					folderValues = new Array();
					folderlist = child;
					for (child = folderlist.firstChild; child != null; child = child.nextSibling) {
						if (child.nodeName == "version") {
							newestVersion = child.value;
						} else if (child.nodeName == "download") {
							downloadUrl = child.value;
						}
					}
					if (parseFloat(newestVersion) > parseFloat(thisVersion)) {
						document.getElementById('update').href = downloadUrl;
						document.getElementById('update').style.display = 'block';
					}
				}
			}
		}
	}
}

// end